$<PDPRSX
GET "LIBHDR"
GET "SPEHDR"
$>PDPRSX


$<CAP1
GET "LIBHDR"
GET ".progs.spehdr"
$>CAP1

LET writemylexword(word) BE			// packed private lexicon
$(
   LET o     = OUTPUT()
   LET addon = word%0 + [word!-1 -> (word!-2)%0+1, 0]

   STATIC $( first=TRUE $)

   Selectoutput(newlexstr)
   linelength := linelength + addon + 1
   TEST linelength > maxlinelength
   THEN $(
		UNLESS first DO NEWLINE()
		first := FALSE
		linelength := addon
	$)
   ELSE WRCH('*S')
   WRITES(word)
   IF word!-1 THEN Writef("=%S",word!-2)

   Selectoutput(o)
$)

AND readsysword( oldword ) BE			// coz it's condensed
// Select user lexicon stream if possible, and read next word from it
// Returns null string if stream not there
$(

$<PDPRSX
    SELECTINPUT( syslexstr )
    $(
	LET p =  ?
$>PDPRSX

$<CAP1
    TEST syslexstr = 0				// CAP wont select on non-existant streams
    THEN oldword%0, oldword!-1 := 0, FALSE	// Return null string
    ELSE
    $(
	LET p =  ?
	SELECTINPUT( syslexstr )
$>CAP1

	p := READN()
	UNRDCH()
	$(
	    TERMINATOR := RDCH()
		IF TERMINATOR<0 | TERMINATOR='*N' | TERMINATOR='*S' | TERMINATOR='='
		   THEN BREAK
		p := p + 1
		oldword%p := TERMINATOR
	$) REPEAT
	oldword%0 := p

	read.correction.for( oldword, TRUE )

    $)
$)

AND readmylexword( word ) BE
// Select user lexicon stream if possible, and read next word from it
// Returns null string if stream not there
$(
    LET p=0

$<PDPRSX
    SELECTINPUT( mylexstr )
$>PDPRSX

$<CAP1
    TEST mylexstr = 0
    THEN word%0, word!-1 := 0, FALSE
    ELSE
    $(
	SELECTINPUT( mylexstr )
$>CAP1

	$(
	    TERMINATOR := RDCH()
		IF TERMINATOR<0 | TERMINATOR='*N' | TERMINATOR='*S' | TERMINATOR='='
		   THEN BREAK
		p := p + 1
		word%p := TERMINATOR
	$) REPEAT
	word%0 := p
	read.correction.for( word, FALSE )
$<CAP1
    $)
$>CAP1
$)

AND read.correction.for( word, system ) BE
	TEST TERMINATOR='='
	THEN $(
		LET w = word!-2
		LET p = system -> Readn(), 0

		IF system THEN
		$(
		   Unrdch()
		   FOR I=1 TO p DO w%I := word%I
		$)

		$(
		    TERMINATOR := RDCH()
			IF TERMINATOR<0 | TERMINATOR='*N' | TERMINATOR='*S'
			   THEN BREAK
			p := p + 1
			w%p := TERMINATOR
		$) REPEAT
		word!-1 := TRUE
		w%0 := p
	     $)
	ELSE word!-1 := FALSE

AND comparestring (a, b) = VALOF		// dictionary compare
$(  LET m, n = a%0, b%0
    LET l =    m<n -> m, n
    LET d = ?

    FOR i = 1 TO l DO				// same with cases equated?
    $(
        d := (CAPITALCH ( a%i ) - CAPITALCH ( b%i ))
        UNLESS d = 0   RESULTIS (d > 0 -> 1, -1)	// return if no
    $)

    d := m - n					// same lengths?
    UNLESS d = 0
        RESULTIS (d > 0 -> 1, -1)		// return if no

    FOR i = 1 TO l DO				// same with same case?
    $(
        d := a%i - b%i
        UNLESS d = 0
            RESULTIS (d > 0 -> 1, -1)		// return if no
    $)

    RESULTIS 0					// its the same word doggonit
$)


AND min (x, y) = (x < y -> x, y)		// guess


$<CAP1
// Routines which are assumed to be available in the library, but which are
// not on CAP


// Capitalize lower case alphabet, assumes no printing chars between lower
// case letters, and always same difference between UC and LC codes

LET capitalch(ch) = 'a' <= ch <= 'z' -> ch + 'A' - 'a', ch


// Readstring - This code pinched from SSE
// 1st arg - buffer in which string will be returned
// 2nd arg - extra character to be used as terminator besides normal ones

AND Readstring( buf, term ) = VALOF
$(
    LET pos = 0
    $(
	TERMINATOR := RDCH()
	IF TERMINATOR='*N' | TERMINATOR=term | TERMINATOR=ENDSTREAMCH |
	   TERMINATOR='*P' | TERMINATOR='*C' | TERMINATOR='*E'
	     THEN BREAK
	pos := pos + 1
	buf%pos := TERMINATOR
    $) REPEAT
    buf%0 := pos
    RESULTIS pos
$)

$>CAP1
